1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249
|
package generators
import (
"bufio"
"errors"
"fmt"
"os"
"path/filepath"
"strings"
incus "github.com/lxc/incus/v6/shared/util"
"github.com/lxc/distrobuilder/v3/image"
"github.com/lxc/distrobuilder/v3/shared"
)
var incusAgentSetupScript = `#!/bin/sh
set -eu
PREFIX="/run/incus_agent"
CDROM="/dev/disk/by-id/scsi-0QEMU_QEMU_CD-ROM_incus_agent"
# Functions.
mount_virtiofs() {
mount -t virtiofs config "${PREFIX}.mnt" >/dev/null 2>&1
}
mount_9p() {
modprobe 9pnet_virtio >/dev/null 2>&1 || true
mount -t 9p config "${PREFIX}.mnt" -o access=0,trans=virtio,size=1048576 >/dev/null 2>&1
}
mount_cdrom() {
mount "${CDROM}" "${PREFIX}.mnt" >/dev/null 2>&1
}
fail() {
# Check if we already have an agent in place.
# This will typically be true during restart in the case of a cdrom-based setup.
if [ -x "${PREFIX}/incus-agent" ]; then
echo "${1}, reusing existing agent"
exit 0
fi
# Cleanup and fail.
umount -l "${PREFIX}" >/dev/null 2>&1 || true
eject "${CDROM}" >/dev/null 2>&1 || true
rmdir "${PREFIX}" >/dev/null 2>&1 || true
echo "${1}, failing"
exit 1
}
# Try getting an agent drive.
mkdir -p "${PREFIX}.mnt"
mount_9p || mount_virtiofs || mount_cdrom || fail "Couldn't mount 9p or cdrom"
# Setup the mount target.
umount -l "${PREFIX}" >/dev/null 2>&1 || true
mkdir -p "${PREFIX}"
mount -t tmpfs tmpfs "${PREFIX}" -o mode=0700,size=50M
# Copy the data.
cp -Ra "${PREFIX}.mnt/"* "${PREFIX}"
# Unmount the temporary mount.
umount "${PREFIX}.mnt"
rmdir "${PREFIX}.mnt"
# Eject the cdrom in case it's present.
eject "${CDROM}" >/dev/null 2>&1 || true
# Fix up permissions.
chown -R root:root "${PREFIX}"
# Attempt to restore SELinux labels.
restorecon -R "${PREFIX}" >/dev/null 2>&1 || true
exit 0
`
type incusAgent struct {
common
}
// RunLXC is not supported.
func (g *incusAgent) RunLXC(img *image.LXCImage, target shared.DefinitionTargetLXC) error {
return ErrNotSupported
}
// RunIncus creates systemd unit files for the agent.
func (g *incusAgent) RunIncus(img *image.IncusImage, target shared.DefinitionTargetIncus) error {
initFile := filepath.Join(g.sourceDir, "sbin", "init")
fi, err := os.Lstat(initFile)
if err != nil {
return fmt.Errorf("Failed to stat file %q: %w", initFile, err)
}
if fi.Mode()&os.ModeSymlink != 0 {
linkTarget, err := os.Readlink(initFile)
if err != nil {
return fmt.Errorf("Failed to read link %q: %w", initFile, err)
}
if strings.Contains(linkTarget, "systemd") {
return g.handleSystemd()
}
if strings.Contains(linkTarget, "busybox") {
return g.getInitSystemFromInittab()
}
return nil
}
return g.getInitSystemFromInittab()
}
// Run does nothing.
func (g *incusAgent) Run() error {
return nil
}
func (g *incusAgent) handleSystemd() error {
systemdPath := filepath.Join("/", "lib", "systemd")
if !incus.PathExists(filepath.Join(g.sourceDir, systemdPath)) {
systemdPath = filepath.Join("/", "usr", "lib", "systemd")
}
incusAgentServiceUnit := fmt.Sprintf(`[Unit]
Description=Incus - agent
Documentation=https://linuxcontainers.org/incus/docs/main/
Before=multi-user.target cloud-init.target cloud-init.service cloud-init-local.service
DefaultDependencies=no
[Service]
Type=notify
WorkingDirectory=-/run/incus_agent
ExecStartPre=%s/incus-agent-setup
ExecStart=/run/incus_agent/incus-agent
Restart=on-failure
RestartSec=5s
StartLimitInterval=60
StartLimitBurst=10
`, systemdPath)
path := filepath.Join(g.sourceDir, systemdPath, "system", "incus-agent.service")
err := os.WriteFile(path, []byte(incusAgentServiceUnit), 0o644)
if err != nil {
return fmt.Errorf("Failed to write file %q: %w", path, err)
}
path = filepath.Join(g.sourceDir, systemdPath, "incus-agent-setup")
err = os.WriteFile(path, []byte(incusAgentSetupScript), 0o755)
if err != nil {
return fmt.Errorf("Failed to write file %q: %w", path, err)
}
udevPath := filepath.Join("/", "lib", "udev", "rules.d")
stat, err := os.Lstat(filepath.Join(g.sourceDir, "lib", "udev"))
if err == nil && stat.Mode()&os.ModeSymlink != 0 || !incus.PathExists(filepath.Dir(filepath.Join(g.sourceDir, udevPath))) {
udevPath = filepath.Join("/", "usr", "lib", "udev", "rules.d")
}
incusAgentRules := `SYMLINK=="virtio-ports/org.linuxcontainers.incus", TAG+="systemd", ENV{SYSTEMD_WANTS}+="incus-agent.service"
`
err = os.WriteFile(filepath.Join(g.sourceDir, udevPath, "99-incus-agent.rules"), []byte(incusAgentRules), 0o400)
if err != nil {
return fmt.Errorf("Failed to write file %q: %w", filepath.Join(g.sourceDir, udevPath, "99-incus-agent.rules"), err)
}
return nil
}
func (g *incusAgent) handleOpenRC() error {
incusAgentScript := `#!/sbin/openrc-run
description="Incus - agent"
command=/run/incus_agent/incus-agent
command_background=true
pidfile=/run/incus-agent.pid
start_stop_daemon_args="--chdir /run/incus_agent"
required_dirs=/run/incus_agent
depend() {
need incus-agent-setup
after incus-agent-setup
before cloud-init
before cloud-init-local
}
`
err := os.WriteFile(filepath.Join(g.sourceDir, "/etc/init.d/incus-agent"), []byte(incusAgentScript), 0o755)
if err != nil {
return fmt.Errorf("Failed to write file %q: %w", filepath.Join(g.sourceDir, "/etc/init.d/incus-agent"), err)
}
err = os.Symlink("/etc/init.d/incus-agent", filepath.Join(g.sourceDir, "/etc/runlevels/default/incus-agent"))
if err != nil {
return fmt.Errorf("Failed to create symlink %q: %w", filepath.Join(g.sourceDir, "/etc/runlevels/default/incus-agent"), err)
}
incusConfigShareMountScript := `#!/sbin/openrc-run
description="Incus - agent - setup"
command=/usr/local/bin/incus-agent-setup
required_dirs=/dev/virtio-ports/
`
err = os.WriteFile(filepath.Join(g.sourceDir, "/etc/init.d/incus-agent-setup"), []byte(incusConfigShareMountScript), 0o755)
if err != nil {
return fmt.Errorf("Failed to write file %q: %w", filepath.Join(g.sourceDir, "/etc/init.d/incus-agent-setup"), err)
}
err = os.Symlink("/etc/init.d/incus-agent-setup", filepath.Join(g.sourceDir, "/etc/runlevels/default/incus-agent-setup"))
if err != nil {
return fmt.Errorf("Failed to create symlink %q: %w", filepath.Join(g.sourceDir, "/etc/runlevels/default/incus-agent-setup"), err)
}
path := filepath.Join(g.sourceDir, "/usr/local/bin", "incus-agent-setup")
err = os.WriteFile(path, []byte(incusAgentSetupScript), 0o755)
if err != nil {
return fmt.Errorf("Failed to write file %q: %w", path, err)
}
return nil
}
func (g *incusAgent) getInitSystemFromInittab() error {
f, err := os.Open(filepath.Join(g.sourceDir, "etc", "inittab"))
if err != nil {
return fmt.Errorf("Failed to open file %q: %w", filepath.Join(g.sourceDir, "etc", "inittab"), err)
}
defer f.Close()
scanner := bufio.NewScanner(f)
for scanner.Scan() {
if strings.Contains(scanner.Text(), "sysinit") && strings.Contains(scanner.Text(), "openrc") {
return g.handleOpenRC()
}
}
return errors.New("Failed to determine init system")
}
|